/*

*************************************************************************

ArmageTron -- Just another Tron Lightcycle Game in 3D.
Copyright (C) 2000  Manuel Moos (manuel@moosnet.de)

**************************************************************************

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
  
***************************************************************************

*/

#include "gStuff.h"
#include "eCoord.h"
#include "tConfiguration.h"
#include "tResourceManager.h"
#include "uInput.h"
#include "tInitExit.h"
#include "nConfig.h"

#include "rSDL.h"
#include "rScreen.h"
#ifndef DEDICATED
#include "rRender.h"

#endif

bool pp_out=1; // or 2d-output?
bool pp_tess_deb=0;

// need to read Unnamed & Anonoymous from language file once a way is found

tString gm_moviepack_name("Unnamed");
tString gm_moviepack_creator("Anonoymous");
static tSettingItem<tString> mov_name("MOVIEPACK_NAME", gm_moviepack_name);
static tSettingItem<tString> mov_by("MOVIEPACK_BY", gm_moviepack_creator);

// network setting item for the reesource repository from tResourceManager.cpp
// may be dangerous, so it's disabled for now.
static nSettingItem<tString> conf_res_repo("RESOURCE_REPOSITORY_SERVER", tResourceManager::resRepoServer);

static tConfItem<bool> grab("MOUSE_GRAB",su_mouseGrab);

bool sg_moviepackInstalled=false; // do we have the mp on disk?
bool sg_moviepackUse=true;       // do we use it?
int  sg_moviepackIndex=32;       // selected Moviepack
int  sg_moviepackUpdated[NUM_MOVIEPACK_ITEMS] = {1};       // Moviepack updated index
bool sg_moviepackInstalledList[NUM_MOVIEPACK_SLOTS]; // store a list of what is installed

// Directory
tString sg_moviepackSlot[NUM_MOVIEPACK_SLOTS + 1] = {tString("Slot_00"),tString("Slot_01"),tString("Slot_02"),tString("Slot_03"),tString("Slot_04"),tString("Slot_05"),tString("Slot_06"),tString("Slot_07"),tString("Slot_08"),tString("Slot_09"),tString("Slot_10"),
				tString("Slot_11"),tString("Slot_12"),tString("Slot_13"),tString("Slot_14"),tString("Slot_15"),tString("Slot_16"),tString("Slot_17"),tString("Slot_18"),tString("Slot_19"),tString("Slot_20"),
				tString("Slot_21"),tString("Slot_22"),tString("Slot_23"),tString("Slot_24"),tString("Slot_25"),tString("Slot_26"),tString("Slot_27"),tString("Slot_28"),tString("Slot_29"),tString("Slot_30"),
				tString("Slot_31"),tString("Bundled_A"),tString("Bundled_B"),tString("Bundled_C"),tString("Bundled_D"),tString("Bundled_E"),tString("Bundled_F"),tString("Bundled_G"),tString("Bundled_H"),tString("Bundled_I")};

// Name from settings.cfg
tString sg_moviepackName[NUM_MOVIEPACK_SLOTS + 1] = {tString("Unnamed"),tString("Unnamed"),tString("Unnamed"),tString("Unnamed"),tString("Unnamed"),tString("Unnamed"),tString("Unnamed"),tString("Unnamed"),tString("Unnamed"),tString("Unnamed"),tString("Unnamed"),
				tString("Unnamed"),tString("Unnamed"),tString("Unnamed"),tString("Unnamed"),tString("Unnamed"),tString("Unnamed"),tString("Unnamed"),tString("Unnamed"),tString("Unnamed"),tString("Unnamed"),
				tString("Unnamed"),tString("Unnamed"),tString("Unnamed"),tString("Unnamed"),tString("Unnamed"),tString("Unnamed"),tString("Unnamed"),tString("Unnamed"),tString("Unnamed"),tString("Unnamed"),
				tString("Unnamed"),tString("Unnamed"),tString("Unnamed"),tString("Unnamed"),tString("Unnamed"),tString("Unnamed"),tString("Unnamed"),tString("Unnamed"),tString("Unnamed"),tString("Unnamed")};

// Creator from settings.cfg
tString sg_moviepackCreator[NUM_MOVIEPACK_SLOTS + 1] = {tString("Anonoymous"),
				tString("Anonoymous"),tString("Anonoymous"),tString("Anonoymous"),tString("Anonoymous"),tString("Anonoymous"),tString("Anonoymous"),tString("Anonoymous"),tString("Anonoymous"),tString("Anonoymous"),tString("Anonoymous"),
				tString("Anonoymous"),tString("Anonoymous"),tString("Anonoymous"),tString("Anonoymous"),tString("Anonoymous"),tString("Anonoymous"),tString("Anonoymous"),tString("Anonoymous"),tString("Anonoymous"),tString("Anonoymous"),
				tString("Anonoymous"),tString("Anonoymous"),tString("Anonoymous"),tString("Anonoymous"),tString("Anonoymous"),tString("Anonoymous"),tString("Anonoymous"),tString("Anonoymous"),tString("Anonoymous"),tString("Anonoymous"),
				tString("Anonoymous"),tString("Anonoymous"),tString("Anonoymous"),tString("Anonoymous"),tString("Anonoymous"),tString("Anonoymous"),tString("Anonoymous"),tString("Anonoymous"),tString("Anonoymous"),tString("Anonoymous")};

				
tString sg_moviepackPathName("moviepacks/"); //Directory prefix
static tConfItem<bool> ump("MOVIEPACK",sg_moviepackUse);
static tConfItem<int> nmp("MOVIEPACK_INDEX", sg_moviepackIndex);

// setting item for double bind (available since version 7)
static nSettingItemWatched<REAL> su_doubleBindTimeoutConf( "DOUBLEBIND_TIME", su_doubleBindTimeout, nConfItemVersionWatcher::Group_Cheating, 7  );

bool sg_MoviePack(){
    return sg_moviepackInstalled && sg_moviepackUse;
}

//const eCoord se_zeroCoord(0,0);

