/*

*************************************************************************

ArmageTron -- Just another Tron Lightcycle Game in 3D.
Copyright (C) 2000  Manuel Moos (manuel@moosnet.de)

**************************************************************************

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
  
***************************************************************************

*/

#ifndef ArmageTron_STUFF_H
#define ArmageTron_STUFF_H


#include "../render/rSDL.h"

#ifdef _MSC_VER
// disable nasty conversion complains of MSVC++
#pragma warning ( disable : 4800 4081 4244 4305 4244)
#endif
#include "tString.h"
#include "tMemManager.h"
#include "defs.h"
#include "tSafePTR.h"

// #define EPS     1E-16

#include <math.h>

#ifndef M_PI
#define M_PI 3.14159
#endif

#define NUM_MOVIEPACK_SLOTS 40
#define NUM_MOVIEPACK_ITEMS 8

extern int sg_moviepackIndex; //Used moviepack

// Moviepack updated index  0=increment 1=floor.png 2=floor_a.png 3=floor_b.png 4=dir_wall.png 5=sky.png 6=preview dir_wall.png 7=rim_wall_*.png
extern int  sg_moviepackUpdated[NUM_MOVIEPACK_ITEMS];

extern tString sg_moviepackPathName; //Path to moviepacks
extern bool sg_moviepackInstalledList[NUM_MOVIEPACK_SLOTS]; // store a list of what is installed for use in menu
extern tString gm_moviepack_name;
extern tString gm_moviepack_creator;
extern tString sg_moviepackSlot[NUM_MOVIEPACK_SLOTS + 1]; //Directory names for each slot
extern tString sg_moviepackName[NUM_MOVIEPACK_SLOTS + 1]; //User provided names for each slot
extern tString sg_moviepackCreator[NUM_MOVIEPACK_SLOTS + 1]; //Created by so & so?

extern bool sr_glOut; // do we have gl-output?

extern bool su_mouseGrab; // grab the mouse in windowed mode

extern bool sr_ZTrick;     // Quake-Style z-buffer trick: do
// not delete the screen, just pait the background with depth test
// disabled. Gives 20% speedup.

//extern bool sr_textOut; // display game text graphically?

extern bool sg_moviepackInstalled; // do we have the mp on disk?
extern bool sg_moviepackUse;       // do we use it?

bool sg_MoviePack();

#ifdef POWERPAK_DEB
extern bool pp_out; // or 2d-output?
extern bool pp_tess_deb;
#endif

// we are going to define all these classes and want to be free
// to declare pointers to them anytime:

class ePoint;
class eHalfEdge;
class eFace;
class ePlayer;
class gCycle;
class eWall;
class eGameObject;
class eCamera;

#endif
